package istia.st.mvc.personnes.tests;

import java.util.Date;

import istia.st.mvc.personnes.dao.DaoException;
import istia.st.mvc.personnes.dao.IDao;
import istia.st.mvc.personnes.entites.Personne;

public class ThreadDaoMajEnfants extends Thread {
	// nom du thread
	private String name;
	// rfrence sur la couche [dao]
	private IDao dao;
	// l'id de la personne sur qui on va travailler
	private int idPersonne;

	// constructeur
	public ThreadDaoMajEnfants(String name, IDao dao, int idPersonne) {
		this.name = name;
		this.dao = dao;
		this.idPersonne = idPersonne;
	}

	// coeur du thread
	public void run() {
		// suivi
		suivi("lanc");
		// on boucle tant qu'on n'a pas russi  incrmenter de 1
		// le nbre d'enfants de la personne idPersonne
		boolean fini = false;
		int nbEnfants = 0;
		while (!fini) {
			// on rcupre une copie de la personne d'idPersonne
			Personne personne = dao.getOne(idPersonne);
			nbEnfants = personne.getNbEnfants();
			// suivi
			suivi("" + nbEnfants + " -> " + (nbEnfants + 1) + " pour la version "+personne.getVersion());
			// attente de 10 ms pour abandonner le processeur
			try {
				// suivi
				suivi("dbut attente");
				// on s'interrompt pour laisser le processeur
				Thread.sleep(10);
				// suivi
				suivi("fin attente");
			} catch (Exception ex) {
				throw new RuntimeException(ex.toString());
			}
			// attente termine - on essaie de valider la copie
			// entre-temps d'autres threads ont pu modifier l'original
			int codeErreur = 0;
			try {
				// incrmente de 1 le nbre d'enfants de cette copie
				personne.setNbEnfants(nbEnfants + 1);
				// on essaie de modifier l'original
				dao.saveOne(personne);
				// on est pass - l'original a t modifi
				fini = true;
			} catch (DaoException ex) {
				// on rcupre le code erreur
				codeErreur = ex.getCode();
				// doit tre une erreur de version 3 - sinon on relance
				// l'exception
				if (codeErreur != 3) {
					throw ex;
				} else {
					// suivi
					suivi(ex.getMessage());
				}
				// l'original a chang - on recommence tout
			}
		}
		// suivi
		suivi("a termin et pass le nombre d'enfants  " + (nbEnfants + 1));
	}

	// suivi
	private void suivi(String message) {
		System.out
				.println(name + " [" + new Date().getTime()+ "] : " + message);
	}
}