package istia.st.mvc.personnes.service;

import istia.st.mvc.personnes.dao.IDao;
import istia.st.mvc.personnes.entites.Personne;

import java.util.Collection;

public class ServiceImpl implements IService {

	// la couche [dao]
	private IDao dao;

	public IDao getDao() {
		return dao;
	}

	public void setDao(IDao dao) {
		this.dao = dao;
	}

	// liste des personnes
	public synchronized Collection getAll() {
		return dao.getAll();
	}

	// obtenir une personne en particulier
	public synchronized Personne getOne(int id) {
		return dao.getOne(id);
	}

	// ajouter ou modifier une personne
	public synchronized void saveOne(Personne personne) {
		dao.saveOne(personne);
	}

	// suppression d'une personne
	public synchronized void deleteOne(int id) {
		dao.deleteOne(id);
	}
}