package istia.st.mvc.personnes.tests;

import java.util.Date;

import istia.st.mvc.personnes.dao.DaoException;
import istia.st.mvc.personnes.entites.Personne;
import istia.st.mvc.personnes.service.IService;

public class ThreadServiceMajEnfants extends Thread {

	// nom du thread
	private String name;

	// rfrence sur la couche [service]
	private IService service;

	// l'id de la personne sur qui on va travailler
	private int idPersonne;

	public ThreadServiceMajEnfants(String name, IService service, int idPersonne) {
		this.name = name;
		this.service = service;
		this.idPersonne = idPersonne;
	}

	public void run() {
		// suivi
		suivi("lanc");
		// on boucle tant qu'on n'a pas russi  incrmenter de 1
		// le nbre d'enfants de la personne idPersonne
		boolean fini = false;
		int nbEnfants = 0;
		while (!fini) {
			// on rcupre une copie de la personne d'idPersonne
			Personne personne = service.getOne(idPersonne);
			nbEnfants = personne.getNbEnfants();
			// suivi
			suivi("" + nbEnfants + " -> " + (nbEnfants + 1)
					+ " pour la version " + personne.getVersion());
			// attente de 10 ms pour abandonner le processeur
			try {
				// suivi
				suivi("dbut attente");
				// on s'interrompt pour laisser le processeur
				Thread.sleep(10);
				// suivi
				suivi("fin attente");
			} catch (Exception ex) {
				throw new RuntimeException(ex.toString());
			}
			// attente termine - on essaie de valider la copie
			// entre-temps d'autres threads ont pu modifier l'original
			int codeErreur = 0;
			try {
				// incrmente de 1 le nbre d'enfants de cette copie
				personne.setNbEnfants(nbEnfants + 1);
				// on essaie de modifier l'original
				service.saveOne(personne);
				// on est pass - l'original a t modifi
				fini = true;
			} catch (DaoException ex) {
				// on rcupre le code erreur
				codeErreur = ex.getCode();
				// si une erreur d'ID ou de version 2 ou un deadlock 4, on
				// ressaie la mise  jour
				switch (codeErreur) {
				case 2:
					suivi("version corrompue ou personne inexistante");
					break;
				case 4:
					suivi("conflit de mise  jour");
					break;
				default:
					// exception non gre - on laisse remonter
					throw ex;
				}
			}
		}
		// suivi
		suivi("a termin et pass le nombre d'enfants  " + (nbEnfants + 1));
	}

	// suivi
	private void suivi(String message) {
		System.out.println(name + " [" + new Date().getTime() + "] : "
				+ message);
	}

}